/* 
 * title : showfont.c - եɽƥ
 * begin : 2002/03/12
 * note  : 
 * make  : gcc showfont.c -o showfont -I/usr/X11R6/include -L/usr/X11R6/lib  -lX11
 *
 */

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <stdio.h>

#define  WIN_WIDTH  600
#define  WIN_HEIGHT 40
#define  MSG   "This is a sample string"
#define  FONT  "-*-Courier-medium-r-normal--30-*-*-*-*-*-*-*"

int main()
{
  Display *d;
  Window w;
  GC gc;
  Font f;
  XEvent e;

  d = XOpenDisplay(NULL);
  w  = XCreateSimpleWindow(d, RootWindow(d, 0),  25,  25,
         WIN_WIDTH, WIN_HEIGHT, 2, BlackPixel(d, 0), WhitePixel(d, 0));
  gc = XCreateGC(d, RootWindow(d, 0), 0, 0);
  /*  եɤ߹  */
  f = XLoadFont(d, FONT);
  /* ǣä˥եȤ */
  XSetFont(d, gc, f);
  XSelectInput(d, w, ExposureMask | ButtonPressMask);
  XMapWindow(d, w);

  while (1) {
    XNextEvent(d, &e);
    /* ɥɽ줿顢ʸľ */
    if (e.type == Expose)
      XDrawString(d, w, gc, 10, 30, MSG, strlen(MSG));
    else 
    /* ܥ󤬲줿顢λ*/
    if (e.type == ButtonPress)
      break;
  }
  XCloseDisplay(d);

}
