/* 
 * title : xeyetest.c  -  ϸ
 * begin : 2002/01/15
 * make  : gcc xeyetest.c -o xeyetest -lm -I/usr/X11R6/include -L/usr/X11R6/lib -lX11
 * 
 * 
 */

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <math.h>
#include <time.h>
#include <stdlib.h>
#include <stdio.h>

/* ̤μ¬Ĺ򤳤ؽޤʥߥ᡼ȥñ̡ */
/* ȡޥˤƼư */
#define  SCREEN_WIDTH 264

/* ̤βĹʥߥ᡼ȥñ̡ */
int scr_width_mm;

/* Ѵ */
int rotate(short *x, short *y, int dir)
{
  double th;
  double wx, wy;

  th = dir * 2 * M_PI / 8;
  wx = (*x) * cos(th) - (*y) * sin(th);
  wy = (*x) * sin(th) + (*y) * cos(th);
  *x = (short) wx + 400;  *y = (short) wy + 400;
}

/* ɥȴĤ */
redraw(Display *d, Window w, GC gc, double sight, int dir)
{
  char title[] = "xeyetest : 00.0";
  short r;
  XPoint rect[4];

  printf("direction : %d\n", dir);

  /* ɥȴĤβ̾Ⱦ¤ */
  r = 7.5 / 2 * DisplayWidth(d, 0) / scr_width_mm / sight;

  /* ɥȴĤη礱ʬФ */
  rect[0].x = r*1.5; rect[0].y =  r/5;
  rotate(&rect[0].x, &rect[0].y, dir);
  rect[1].x = r*1.5; rect[1].y = -r/5;
  rotate(&rect[1].x, &rect[1].y, dir);
  rect[2].x = 0; rect[2].y = -r/5;
  rotate(&rect[2].x, &rect[2].y, dir);
  rect[3].x = 0; rect[3].y =  r/5;
  rotate(&rect[3].x, &rect[3].y, dir);

  XClearWindow(d, w);
  /* ɥȴĤοʹ */
  XSetForeground(d, gc, BlackPixel(d, 0));
  /* ɥȴĤʤ */
  XSetLineAttributes(d, gc, r/2.5, LineSolid, CapButt, JoinMiter);
  /* ɥȴĤ礭αߤ */
  XDrawArc(d, w, gc, 400-r*4/5, 400-r*4/5, r*8/5, r*8/5, 0, 360*64); 
  /* 礱ʬ١ */
  XSetForeground(d, gc, WhitePixel(d, 0));
  /* 礱ʬ */
  XFillPolygon(d, w, gc, rect, 4, Convex, CoordModeOrigin);
  /* ȥ */
  sprintf(title, "xeyetest : %2.1f", sight);
  XStoreName(d, w, title);
}

main()
{
  Display *d;
  Window w;
  GC gc;
  XEvent e;
  /* Ͻܿͤ͡ʿѻϤϣʤǤ */
  double sight = 1.2;
  /* 礱ʬ */
  int dir = 0;
  /* ΰ */
  time_t curr;

  /*  */
  time(&curr);
  srand(curr);

  d = XOpenDisplay(NULL);

#ifdef SCREEN_WIDTH
  /* ʪ碌 */
  scr_width_mm = SCREEN_WIDTH;
  printf("ʪ碌\n");
#else 
  /* ФȤ */
  scr_width_mm = DisplayWidthMM(d, 0);
  printf("ޥ\n");
#endif /* SCREEN_WIDTH */

  w = XCreateSimpleWindow(d, RootWindow(d, 0), 100, 100, 800, 800, 2, BlackPixel(d, 0), WhitePixel(d, 0));
  gc = XCreateGC(d, w, 0, 0);
  XSelectInput(d, w, ExposureMask | ButtonPressMask);
  XMapWindow(d, w);

  while (1){
    XNextEvent(d, &e);
    if (e.type == Expose)
      redraw(d, w, gc, sight, dir);
    if (e.type == ButtonPress)
      if (e.xbutton.button == 1) {  /* Ѥ */
	dir = rand()*8.0/RAND_MAX;
	redraw(d, w, gc, sight, dir);
      }
      else 
      if (e.xbutton.button == 2) {  /* ̾ٿ夲 */
	sight += 0.1;
	redraw(d, w, gc, sight, dir);
      }
      else
      if (e.xbutton.button == 3) {  /* ٿ */
	sight -= 0.1;
	if (sight <= 0.1) sight = 0.1;
	redraw(d, w, gc, sight, dir);
      }

  }
  XCloseDisplay(d);
}

































