/* 
 * title : xgolf.c - ʰץե
 * begin : 2001/12/25
 * make  : gcc xgolf.c -o xgolf -lm -I/usr/X11R6/include -L/usr/X11R6/lib -lX11
 *
 */

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <time.h>

/* ᥤΥɥ礭 */
#define  WIN_WIDTH  640
#define  WIN_HEIGHT 480
/* ֥ɥ礭 */
#define  SUB_WIDTH  80
#define  SUB_HEIGHT 80
/* ѥɥ礭 */
#define  POW_WIDTH  150
#define  POW_HEIGHT 30
/* ѥ */
#define  MAX_POWER  150
/* åץʸ */
#define  MSG_CUPIN  "Nice cup in !"
/* ɽ֤濴 */
#define  WIND_X  600
#define  WIND_Y  440

/* åɽ */
int draw_pole(Display *d, Window w, GC gc, int xc, int yc)
{
  XDrawArc(d, w, gc, xc-5, yc-5, 10, 10, 0, 360*64);
  XDrawLine(d, w, gc, xc, yc, xc, yc-30);
  XDrawLine(d, w, gc, xc, yc-30, xc+10, yc-25);
  XDrawLine(d, w, gc, xc+10, yc-25, xc, yc-20);
}


int main()
{
  Display *d;
  Window r, w, w1, w2;
  GC gc, gc1;
  XEvent e;
  unsigned long black, white;
  /*  */
  time_t curr;
  /* åȳ */
  double th;
  /*  */
  double dir;
  /*  */
  int wind;
  /* Ƽե饰 */
  int f_cupin, f_shot;
  /* ۡ */
  int xh = 100, yh = 400;
  /* åװ */
  int xc = 500, yc = 100;
  /* ѡ */
  int par = 0;
  /* ѥ */
  int pow = 0;

  /*ν */
  time(&curr);
  srand(curr);

  d = XOpenDisplay(NULL);
  r = RootWindow(d, 0);
  black = BlackPixel(d, 0);
  white = WhitePixel(d, 0);
  /* ǣ */
  gc  = XCreateGC(d, r, 0, 0);
  gc1 = XCreateGC(d, r, 0, 0);
  XSetLineAttributes(d, gc1, 5, LineSolid, CapButt, JoinMiter);
  /* ɥ  */
  w  = XCreateSimpleWindow(d, r, 25, 25,
           WIN_WIDTH, WIN_HEIGHT, 2, black, white);
  /* åȡݥѥ֥ɥ */
  w1 = XCreateSimpleWindow(d, w, xh-40, yh-40, SUB_WIDTH, SUB_HEIGHT, 0, black, white);
  /* ѥѥɥ */
  w2 = XCreateSimpleWindow(d, r, 25, 25, POW_WIDTH, POW_HEIGHT, 2, black, white);
  /*  */
  XSelectInput(d, w,  ExposureMask | ButtonPressMask | ButtonReleaseMask | PointerMotionMask);
  /* ǣУͣͣꤹȡ */
  /* ݥ󥿤κɸ֥ɥ⳰ǰäƤޤΤǡ */
  /* ǤϻꤷƤޤ */
  XSelectInput(d, w1, ExposureMask | ButtonPressMask | ButtonReleaseMask);
  /* ¹ɥˤ륯åԥ󥰤β */
  /* ݡΥեɽ٤ν */
  XSetSubwindowMode(d, gc, IncludeInferiors);
  /* ɥޥåפ */
  XMapWindow(d, w);
  XMapWindow(d, w2);
  XMapSubwindows(d, w);
  /* ѥΥɥ˥ȥꤹ */
  XStoreName(d, w2, "Power Gauge");

  /*ᥤ롼 */
  f_cupin = 0;
  while (!f_cupin) {
    printf("Par : %d\n", ++par);
    XClearWindow(d, w);
    /* 褺ȶ */
    dir = (2*M_PI*rand())/RAND_MAX;
    wind = (30.0*rand())/RAND_MAX;
    /* åװ֤ΰư */
    XMoveWindow(d, w1, xh-40, yh-40);
    draw_pole(d, w, gc, xc, yc);

    /* ǤФ */
    f_shot = False;
    while (!f_shot) {
      XNextEvent(d, &e);
      if (e.type == Expose) {
        XRaiseWindow(d, w2);
        draw_pole(d, w, gc, xc, yc);
        XDrawArc(d, w, gc, WIND_X-5, WIND_Y-5, 10, 10, 0, 360*64);
        XDrawLine(d, w, gc, WIND_X, WIND_Y, 
                    WIND_X+wind*cos(dir), WIND_Y+wind*sin(dir));
      } else
      /* ܥ򲡤顢 */
      if (e.type == ButtonPress) 
        /* åȥե饰ꤷơ롼æФν򤹤 */
	f_shot = True;
      else
      /* ݥ󥿤ư顢 */
      if (e.type == MotionNotify) {
        /* ؼ饤ľ */
        th = atan2((double)(e.xbutton.y-yh), (double)(e.xbutton.x-xh));
        XClearWindow(d, w1);
        draw_pole(d, w, gc, xc, yc);
        XDrawArc(d, w1, gc, 0, 0, SUB_WIDTH-1, SUB_HEIGHT-1, 0, 360*64);
	XDrawLine(d, w1, gc, SUB_WIDTH/2, SUB_HEIGHT/2,
                    (SUB_WIDTH/2-5)*cos(th)+SUB_WIDTH/2,
                    (SUB_HEIGHT/2-5)*sin(th)+SUB_HEIGHT/2);
      }
    }

    /* ³ơǤФϤؼ */
    f_shot = False;
    pow = 0;
    XMapRaised(d, w2);
    while (!f_shot) {
      /* ѥɽ */
      XClearWindow(d, w2);
      XDrawLine(d, w2, gc1, 0, POW_HEIGHT/2, pow, POW_HEIGHT/2);
      XCheckMaskEvent(d, ButtonReleaseMask, &e);
      if (e.type == ButtonRelease) 
	f_shot = True;
      /* 䤹ֳ֤ϣ */
      usleep(10000);
      /* ¤˹Ԥä顢᤹ */
      if (++pow >= MAX_POWER) pow = 0;
    }

    /* θơܡФ */
    xh = xh + 2*pow*cos(th) + wind*cos(dir);
    yh = yh + 2*pow*sin(th) + wind*sin(dir);

    /* åסĴ٤ */
    if ((xc-xh)*(xc-xh)+(yc-yh)*(yc-yh) <= 25)
      f_cupin = True;
  }

  /* åס */
  XUnmapWindow(d, w1);
  XClearWindow(d, w1);
  draw_pole(d, w, gc, xc, yc);
  puts(MSG_CUPIN);

  /* ;Ĥ٤ˡܥԤ */
  while (1) {
    XNextEvent(d, &e);
    if (e.type == Expose)
      draw_pole(d, w, gc, xc, yc);
    else
    if (e.type == ButtonPress)
      break;
  }
  XCloseDisplay(d);
}
