/* 
 * title : xnumber.c - 
 * begin : 2001/10/31
 * note  : 
 * make  : gcc xnumber.c -o xnumber -I/usr/X11R6/include -L/usr/X11R6/lib  -lX11
 *
 */

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <stdio.h>

#define  WIN_WIDTH  640
#define  WIN_HEIGHT 480
#define  MSG_1   "Is there your number here ?"
#define  MSG_2   "Your number may ..."
#define  MSG_3   "Press Mouse button to exit."
#define  FONT_1  "-*-Courier-medium-r-normal--30-*-*-*-*-*-*-*"
#define  FONT_2  "-*-Helvetica-medium-r-normal--200-*-*-*-*-*-*-*"


int main()
{
  Display *d;
  Window r, w, win_yes, win_no;
  Pixmap p;
  GC gc;
  Font f1, f2;
  XEvent e;
  XSetWindowAttributes a;
  unsigned long black, white;
  int i, j, k, flg, idx, guess = 0;
  char num[3] = "00";

  d = XOpenDisplay(NULL);
  r = RootWindow(d, 0);
  black = BlackPixel(d, 0);
  white = WhitePixel(d, 0);
  /*  եɤ߹  */
  f1 = XLoadFont(d, FONT_1);
  f2 = XLoadFont(d, FONT_2);
  /* ɥ  */
  w  = XCreateSimpleWindow(d, r,  25,  25,
         WIN_WIDTH, WIN_HEIGHT, 2, black, white);
  /* win_yes, win_no ϡ󡿣ܥ */
  win_yes = XCreateSimpleWindow(d, w, 100, 430,
         80, 30, 2, black, white);
  win_no = XCreateSimpleWindow(d, w, 470, 430,
         80, 30, 2, black, white);
  gc = XCreateGC(d, r, 0, 0);
  XSelectInput(d, w,   ExposureMask | ButtonPressMask);
  XSelectInput(d, win_yes,  ExposureMask | ButtonPressMask);
  XSelectInput(d, win_no,   ExposureMask | ButtonPressMask);
  XMapWindow(d, w);
  XMapSubwindows(d, w);

  for (idx = 1; idx < 128; idx <<= 1) {
    /* Expose Ȥȯ̾õ */
    XClearArea(d, w, 0, 0, WIN_WIDTH, WIN_HEIGHT, True);
    for (flg = -1; flg == -1;) {
      XNextEvent(d, &e);
      switch (e.type) {
      case Expose :
	/* ɥľ */
        XSetFont(d, gc, f1);
        XDrawString(d, w, gc, 50, 400, MSG_1, strlen(MSG_1));
        k = 1;
        for (j = 50; j < 400; j += 35)
          for (i = 25; i < 610; i +=60) {
            if ((k & idx) != 0) {
              sprintf(num, "%3d", k);
              XDrawString(d, w, gc, i, j, num, 3);
            }
            k++;
          }
        XDrawString(d, win_yes, gc, 5, 25, "Yes", 3);
        XDrawString(d, win_no,  gc, 5, 25, "No",  2);

      break;
      case ButtonPress :
	/* ܥ󲡲å */
        if (e.xany.window == win_yes) {
          flg = 1;
	  guess += idx;
        }
        if (e.xany.window == win_no) {
          flg = 0;
        }
      }
    }
  }

  /* ɽ */
  XUnmapSubwindows(d, w);
  XClearArea(d, w, 0, 0, WIN_WIDTH, WIN_HEIGHT, True);
  while (1) {
    XNextEvent(d, &e);
    switch (e.type) {
    case Expose :
      XSetFont(d, gc, f1);
      XDrawString(d, w, gc, 30, 100, MSG_2, strlen(MSG_2));
      XDrawString(d, w, gc, 80, 450, MSG_3, strlen(MSG_3));
      XSetFont(d, gc, f2);
      sprintf(num, "%3d", guess);
      XDrawString(d, w, gc, 150, 350, num, 3);
    break;
    case ButtonPress :
      XCloseDisplay(d);
      exit(0);
    }
  }
}
