/* 
 * title : xpet.c - Ǿڥåȡ
 * begin : 2001/11/28
 * note  : 
 * make  : gcc xpet.c -o xpet -I/usr/X11R6/include -L/usr/X11R6/lib  -lX11
 *
 */

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <stdio.h>
#include <string.h>
#include <signal.h>

/* ǾڥåȲ */
#include "min_0.xbm"
#include "min_1.xbm"
#include "min_2.xbm"
#include "min_3.xbm"
#include "min_4.xbm"

/* ɥ礭 */
#define  WIN_WIDTH  64
#define  WIN_HEIGHT 64
/* Ǿڥåȡϥ׽ */
#define  STOMACH_INIT  3
/* ϥץ󥿡 */
#define  INTERVAL  3
/* ϥ׾ */
#define  STOMACH_LIMIT  20
/* ε */
#define  FEED 4

/* ڥåȤΡʸ׹¤Υƥץ졼 */
struct MONKU {
  char *str;
  int  x;
  int  y;
  Window  win;
  Pixmap  pics;
};
/* ʸ */
#include "monku.h"

Display  *d;
Window  win;
GC  gc;
Pixmap  p;
Font  f;

/* ϥ */
int  stomach = STOMACH_INIT;
/* ܡץ */
int  anger_level = 0;
/* ɥ¸ */
int  wx, wy;

/* ڥåȡʸɽ */
int drawMonku(int  i)
{
  char  *idx, buf[1024];

  strcpy(buf, monku[i].str);
  for (idx = buf; *idx != '\0'; idx++) {
    *idx = *idx & 0x7f;
  }
  XDrawString16(d, monku[i].win, gc, 5, 30, (XChar2b *)buf, strlen(buf));
}

/* ڥåɽ */
int drawPet(int  i)
{
  if (i > 0) {
    XMapWindow(d, monku[i].win);
    XMoveWindow(d, monku[i].win, monku[i].x + wx, monku[i].y + wy);
    XRaiseWindow(d, monku[i].win);
    drawMonku(i);
  }
  /* ɥΥڥåȲ򹹿 */
  XCopyArea(d, monku[i].pics, win, gc, 0, 0, 64, 64, 0, 0);
  XFlush(d);
}

/* ʥ */
void sig_happen()
{
  /* ϥפ򸺤餷ˤʤä顢 */
  if (stomach-- <= 0) {
    stomach = 0;
    /* ܡץ򣱤ľ夲 */
    if (++anger_level >= N-1) anger_level = N-1;
  } else {
  /* ǤʤСܡץ򣰤᤹ */
    anger_level = 0;
  }
  /* ڥåȡľ */
  drawPet(anger_level);
  /* 顼ॷʥ */
  if (signal(SIGALRM, sig_happen) == SIG_ERR) {
    perror("signal");
    exit(1);
  }
  /* Υ顼 */
  alarm(INTERVAL);
}


int main(int argc, char **argv)
{
  XEvent  e;
  XSetWindowAttributes  win_attr;
  XSizeHints  win_sizehint;
  int  i, idx = 1;

  /* ޥɥ饤󤫤ѥ᥿ */
  while (idx < argc) {
    /* إɽ */
    if (strcmp(argv[idx], "-h") == 0) {
      fprintf(stderr, "*** Dennou pet on X.\n");
      fprintf(stderr, "Usage : %s\n", argv[0]);
      fprintf(stderr, "options as follows:\n");
      fprintf(stderr, "  [-h]\n");
      fprintf(stderr, "see document for more informations, thanks.\n");
      exit(1);
    }
    idx++;
  }

  d = XOpenDisplay(NULL);
  win_attr.override_redirect = True;

  win  = XCreateSimpleWindow(d, RootWindow(d, 0),  25,  25,
         WIN_WIDTH, WIN_HEIGHT, 2, BlackPixel(d, 0), WhitePixel(d, 0));
  for (i = 0; i < N; i++) {
    monku[i].win = XCreateSimpleWindow(d, RootWindow(d, 0), 100, 430,
           strlen(monku[i].str)*12+10, 36, 1, BlackPixel(d, 0), WhitePixel(d, 0));
    XChangeWindowAttributes(d, monku[i].win, CWOverrideRedirect, &win_attr);
  }

  /* ɥޥ͡㡼ˤ륦ɥ礭ѹ޻ߤ */
  win_sizehint.flags = USSize | PMinSize | PMaxSize;
  win_sizehint.min_width  = WIN_WIDTH;
  win_sizehint.min_height = WIN_HEIGHT;
  win_sizehint.max_width  = WIN_WIDTH;
  win_sizehint.max_height = WIN_HEIGHT;
  XSetWMNormalHints(d, win, &win_sizehint);

  /* ֿͳѡʲˡפǥڥåȤγѰդƤ */
  monku[0].pics = XCreatePixmapFromBitmapData(d, win, min_0_bits, min_0_width, min_0_height, BlackPixel(d, 0), WhitePixel(d, 0), DefaultDepth(d, 0));
  monku[1].pics = XCreatePixmapFromBitmapData(d, win, min_1_bits, min_1_width, min_1_height, BlackPixel(d, 0), WhitePixel(d, 0), DefaultDepth(d, 0));
  monku[2].pics = XCreatePixmapFromBitmapData(d, win, min_2_bits, min_2_width, min_2_height, BlackPixel(d, 0), WhitePixel(d, 0), DefaultDepth(d, 0));
  monku[3].pics = XCreatePixmapFromBitmapData(d, win, min_3_bits, min_3_width, min_3_height, BlackPixel(d, 0), WhitePixel(d, 0), DefaultDepth(d, 0));
  monku[4].pics = XCreatePixmapFromBitmapData(d, win, min_4_bits, min_4_width, min_4_height, BlackPixel(d, 0), WhitePixel(d, 0), DefaultDepth(d, 0));

  gc = XCreateGC(d, win, 0, 0);
  f = XLoadFont(d, FONT_NAME);
  XSetFont(d, gc, f);
  XSelectInput(d, win,  ExposureMask | ButtonPressMask | StructureNotifyMask);
  for (i = 0; i < N; i++) {
    XSelectInput(d, monku[i].win,   ExposureMask);
  }
  XMapWindow(d, win);

  /* 顼ॷʥ */
  if (signal(SIGALRM, sig_happen) == SIG_ERR) {
    perror("signal");
    exit(1);
  }
  /* 顼 */
  alarm(INTERVAL);

    while (1) {
      /* ȼ  */
      XNextEvent(d, &e);
      /* ܥ󲡲ǡֵ¡ */
      if (e.type == ButtonPress) {
        /* ʸ祦ɥ */
        for (i = 0; i < N; i++)
          XUnmapWindow(d, monku[i].win);
        /* ܡץ򣰤ˤ */
        anger_level = 0;
        /* ϥפ */
        stomach += FEED;
        /* (ϥפˤϾ¤) */
        if (stomach > STOMACH_LIMIT) stomach = STOMACH_LIMIT;
        /* ɥΥڥåȲ򹹿 */
        XCopyArea(d, monku[anger_level].pics, win, gc, 0, 0, 64, 64, 0, 0);
      } else
      /* ᥤ󥦥ɥ줿 */
      if (e.type == Expose) {
        /* ʸ祦ɥɽ */
        for (i = 0 ; i <= anger_level; i++) {
          XRaiseWindow(d, monku[i].win);
          drawMonku(i);
        }
        /* ɥΥڥåȲ򹹿 */
        XCopyArea(d, monku[anger_level].pics, win, gc, 0, 0, 64, 64, 0, 0);
      } else
      /* ɥư */
      if (e.type == ConfigureNotify) {
        /* ʸ祦ɥư */
        wx = e.xconfigure.x;
        wy = e.xconfigure.y;
        for (i = 0 ; i <= anger_level; i++) {
          XMoveWindow(d, monku[i].win, monku[i].x + wx, monku[i].y + wy);
          drawMonku(i);
        }

      }
    }

  XCloseDisplay(d);

}
