/* 
 * title : xscreen.c  -  showing copy image of screen
 * begin : 2002/03/10
 * make  : gcc xscreen.c -o xscreen -I/usr/X11R6/include -L/usr/X11R6/lib -lX11
 * 
 */

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <stdlib.h>

/* ߤ */
#ifdef RUN
#define  TIME_DRAW 0
#else
#define  TIME_DRAW 20
#endif
/* ߤȾ¤κ */
#define  CIRCLE_RADIUS  300

main()
{
  Display  *d;
  Window  w;
  Pixmap  p;
  GC  gc;
  XEvent  e;
  XSetWindowAttributes  attr;
  time_t  curr;
  struct tm  *now;
  int x, y, r, ti = TIME_DRAW;

  /* Υͤ */
  time(&curr);
  srand(curr);

  d = XOpenDisplay(NULL);
  w = XCreateSimpleWindow(d, RootWindow(d, 0), 0, 0, DisplayWidth(d, 0), DisplayHeight(d, 0), 0, BlackPixel(d, 0), WhitePixel(d, 0));
  p = XCreatePixmap(d, RootWindow(d, 0), DisplayWidth(d, 0), DisplayHeight(d, 0), DefaultDepth(d, 0));
  XSelectInput(d, w, ButtonPressMask);
  gc = XCreateGC(d, p, 0, 0);
  /* ɥޥ͡㡼β޻ߤ */
  /* ʥɥȤդʤ֤˥ɥ֤١ */
  attr.override_redirect = True;
  XChangeWindowAttributes(d, w, CWOverrideRedirect, &attr);
  /* ιԤʤȥ꡼󥤥᡼ʤ */
  /* ʥȥȤƥѥ뤷ӤƤߤƲ */
  XSetSubwindowMode(d, gc, IncludeInferiors);
  /* طʲԥåޥåפ¸ */
  XCopyArea(d, RootWindow(d, 0), p, gc, 0, 0, DisplayWidth(d, 0), DisplayHeight(d, 0), 0, 0);
  XMapWindow(d, w);
  /* ɥޥåפ顢ԥåޥåפ饦ɥزܤ */
  XCopyArea(d, p, w, gc, 0, 0, DisplayWidth(d, 0), DisplayHeight(d, 0), 0, 0);

  while (1) {
    XCheckMaskEvent(d, ButtonPressMask, &e);
    /* ܥ줿齪λ */
    if (e.type == ButtonPressMask && e.xbutton.button == Button3) break;
    ti++;
    /* ֤ˤʤä */
    if (ti >= TIME_DRAW) {
      /* 󥿤򥯥ꥢ */
      ti = 0;
      /* ߤ */
      x = ((double)rand() * DisplayWidth(d, 0)) / RAND_MAX;
      y = ((double)rand() * DisplayHeight(d, 0)) / RAND_MAX;
      r = ((double)rand() * CIRCLE_RADIUS) / RAND_MAX;
#ifdef RUN
      XCopyArea(d, w, w, gc, x, 0, 1, DisplayHeight(d, 0), x, 1); 
#else
      XSetForeground(d, gc, WhitePixel(d, 0));
      XDrawArc(d, w, gc, x-r, y-r, 2*r, 2*r, 0, 360*64);
      XSetForeground(d, gc, BlackPixel(d, 0));
      XFillArc(d, w, gc, x-r, y-r, 2*r, 2*r, 0, 360*64);
#endif
    }
    /* ߥõٻ */
    usleep(1000);
  }
  XCloseDisplay(d);
}
