/* 
 * title : xstick.c  -  䵻楯饤ȡ
 * begin : 2002/03/21
 * note  : 饤ȡŪʥ̿
 * make  : gcc xstick.c -o xstick -I/usr/X11R6/include -L/usr/X11R6/lib -lX11
 * 
 */

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xatom.h>
#include <stdio.h>
#include <string.h>


/* եȻŬѹƲ */
#define ALPHA_FONT "-*-helvetica-medium-r-normal--16-*-*-*-*-*-*-*"
#define KANJI_FONT "-jis-fixed-medium-r-normal--16-*-*-*-*-*-jisx0208.1983-0"
/* ɥ礭ʤŬѹƲ */
#define WIN_WIDTH  325
#define WIN_HEIGHT 20
/* ʸĹ */
#define STR_LEN  128
/* ̿˻Ȥȥ̾ */
#define ATOM_NAME  "X-HUSEN-SHI"
#define ATOM_CMD   "MESSAGE"


/* functions */

main(int argc, char *argv[])
{
  Display  *disp;
  Window  win, *w2;
  GC  gc_a, gc_k;
  XEvent  evnt;
  Atom  a1, a2, type;
  XClientMessageEvent  cm;

  char  msg[STR_LEN];
  int  fmt;
  unsigned long nitems, left;
  char  *i;
  int   idx;


  /* ޥɥ饤󤫤ѥ᥿ */
  while (idx < argc) {
    /* إɽ */
    if (strcmp(argv[idx], "-h") == 0) {
      fprintf(stderr, "*** Tiny husenshi client for X.\n");
      fprintf(stderr, "Usage : %s  <message in EUC>\n", argv[0]);
      fprintf(stderr, "options as follows:\n");
      fprintf(stderr, "  [-h]\n");
      fprintf(stderr, "see document for more informations, thanks.\n");
      exit(1);
    } else {
      strcpy(msg, argv[idx]);
    }
    idx++;
  }

  disp = XOpenDisplay(NULL);
  /* ɥߤ */
  win = XCreateSimpleWindow(disp, RootWindow(disp, 0),
            10, 900, WIN_WIDTH, WIN_HEIGHT, 2, BlackPixel(disp, 0), WhitePixel(disp, 0));
  /* ꡧܥ˽Ϫɥ礭ѹ */
  XSelectInput(disp, win, ExposureMask | ButtonPressMask | StructureNotifyMask);

  /* ȥȡ̿륦ɥɣĤμ */
  a1 = XInternAtom(disp, ATOM_NAME, False);
  if (XGetWindowProperty(disp, RootWindow(disp, 0), a1, 0, 4, False,
        XA_WINDOW, &type, &fmt, &nitems, &left, (unsigned char**)&w2)
          != Success || type != XA_WINDOW)
    fprintf(stderr, "cannot get remote window id.\n");
  a2 = XInternAtom(disp, ATOM_CMD, False);

  cm.type = ClientMessage;
  cm.display = disp;
  cm.window = *w2;
  cm.message_type = a2;
  cm.format = 32;

  fprintf(stderr, "%s\n", msg);
  for (i = msg; *i != '\0'; i++) {
    cm.data.b[0] = *i;
    XSendEvent(disp, *w2, False, NoEventMask, (XEvent *)&cm);
  }
    cm.data.b[0] = '\0';
    XSendEvent(disp, *w2, False, NoEventMask, (XEvent *)&cm);

  XCloseDisplay(disp);

}
