/* 
 * title : xtama.c
 * begin : 2001/10/26
 * note  : 
 * make  : gcc xtama.c -o xtama -I/usr/X11R6/include -L/usr/X11R6/lib -lX11
 *
 */

#include  <X11/Xlib.h>
#include  <X11/Xutil.h>
#include  <stdio.h>

/* ֵפȡΥޥΥѥ */
#include  "tama.xbm"
#include  "tama_msk.xbm"
/* ɤߤο */
#define  N  5
/* ɸ */
#define  XPOS  30
#define  YPOS  30

/* طɤѤι¤Υƥץ졼 */
struct BackPix {
  int  x;
  int  y;
  Pixmap  plane;
};

struct BackPix  back[N];

Display  *d;
Window  w;
Pixmap  pat, msk;
GC  gc, gc1;
XEvent  e;
XSetWindowAttributes  att;
XColor  col_red, col_exact;
/* ֵץɥΰư */
int  dx = 16, dy = 16;
/* ɤطʤΥǥ */
int  idx;

/* ǥΥԥåޥåطʤߡΰ֤׻ */
int getBack(int i)
{
  int xp, yp, pre;

  i = i  % N;
  pre = (i + N - 1) % N;
  /* ɸη׻ */
  xp = back[pre].x + dx;
  if (xp > DisplayWidth(d, 0) - tama_width) {
    xp = DisplayWidth(d, 0) - tama_width;
    dx = - dx;
  }
  else 
  if (xp < 0) {
    xp = 0;
    dx = - dx;
  }
  back[i].x = xp;
  /* ĺɸη׻ */
  yp = back[pre].y + dy;
  if (yp > DisplayHeight(d, 0) - tama_height) {
    yp = DisplayHeight(d, 0) - tama_height;
    dy = - dy;
  }
  else 
  if (yp < 0) {
    yp = 0;
    dy = - dy;
  }
  back[i].y = yp;
  /* طʤɤߤ */
  XCopyArea(d, RootWindow(d, 0), back[i].plane, gc, xp, yp, tama_width, tama_height, 0, 0);
}


int main(int argc, char **argv)
{
  int  arg_idx = 1, xp = XPOS, yp = YPOS;

  /* ޥɥ饤󤫤ѥ᥿ */
  while (arg_idx < argc) {
    /* إɽ */
    if (strcmp(argv[arg_idx], "-h") == 0) {
      fprintf(stderr, "*** Motion mascot on X.\n");
      fprintf(stderr, "Usage : %s [-x <x pos>] [-y <y pos>]\n", argv[0]);
      fprintf(stderr, "options as follows:\n");
      fprintf(stderr, "  [-h]\n");
      fprintf(stderr, "  [-x <x position : default=%d>]\n", XPOS);
      fprintf(stderr, "  [-y <y position : default=%d>]\n", YPOS);
      fprintf(stderr, "see document for more informations, thanks.\n");
      exit(1);
    } else
    /* ɸ */
    if (strcmp(argv[arg_idx], "-x") == 0)
      sscanf(argv[++arg_idx], "%d", &xp);
    else
    /* ɸ */
    if (strcmp(argv[arg_idx], "-y") == 0)
      sscanf(argv[++arg_idx], "%d", &yp);
    else {
      fprintf(stderr, "unknown option : %s\n", argv[arg_idx]);
      exit(1);
    }
    arg_idx++;
  }

  d = XOpenDisplay(NULL);

  /* ֤ݥȤ˻Ȥ */
  XAllocNamedColor(d, DefaultColormap(d, 0), "red", &col_red, &col_exact);
  /* ɽ륦ɥ */
  w = XCreateSimpleWindow(d, RootWindow(d, 0), 0, 0, tama_width, tama_height, 0, BlackPixel(d, 0), WhitePixel(d, 0));
  /* ȥޥϣţ */
  XSelectInput(d, w, ExposureMask);
  /* ֵץѥԥåޥåפɤ߹Ǥ */
  pat = XCreatePixmapFromBitmapData(d, w, tama_bits, tama_width, tama_height, BlackPixel(d, 0), col_red.pixel, DefaultDepth(d, 0));
  /* ޥѥϥӥåȥޥåפ */
  msk = XCreateBitmapFromData(d, w, tama_msk_bits, tama_width, tama_height);
  /* ɥޥ͡㡼βߤᤵ */
  att.override_redirect = True;
  XChangeWindowAttributes(d, w, CWOverrideRedirect, &att);
  /* ٤Фʤ顢ǣäߤƤ */
  /* 롼ȥɥѤΣǣ */
  gc = XCreateGC(d, RootWindow(d, 0), 0, 0);
  /* ϡֵץѥɽΰ٤Σǣ */
  /* ѥɽ˥ޥԤΤǡ̤Σǣäɬ */
  gc1 = XCreateGC(d, w, 0, 0);
  /* ١֥ɥΥåԥ󥰤  */
  XSetSubwindowMode(d, gc, IncludeInferiors);
  /* ޥѥ */
  XSetClipMask(d, gc1, msk);
  /* ɥν */
  back[N-1].x = xp;
  back[N-1].y = yp;
  /* طʼ */
  for (idx = 0; idx < N; idx++) {
    back[idx].plane = XCreatePixmap(d, RootWindow(d, 0), tama_width, tama_height, DefaultDepth(d, 0));
    getBack(idx);
  }
  XMapWindow(d, w);

  idx = 0;
  while (1) {
    /* طʤѰդƤ */
    XSetWindowBackgroundPixmap(d, w, back[idx].plane);
    /* öɥ򥯥䤹 */
    /* Ǥطʤɽ */
    XClearWindow(d, w);
    /* ɥư */
    XMoveWindow(d, w, back[idx].x, back[idx].y);
    /* ˡ־ˤʤͤˤ */
    XRaiseWindow(d, w);
    /* ޥ֤ưƤ */
    XSetClipOrigin(d, gc, back[idx].x, back[idx].y);  
    /* ֵפɽ */
    XCopyArea(d, pat, w, gc1, 0, 0, tama_width, tama_height, 0, 0);
    /* ǰΰ */
    XFlush(d);
    /* Ԥ */
    usleep(200000);
    /* طʤɤߤ */
    getBack(idx+N-1);
    /* طʥǥ򹹿 */
    idx = (idx + 1) % N;
  }

}
