/* 
 * title : xtrace.c
 * begin : 2001/10/31
 * note  : 
 * make  : gcc xtrace.c -o xtrace -I/usr/X11R6/include -L/usr/X11R6/lib -lX11
 *
 */

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <stdio.h>

/* ꡼ȥɥ礭Ψ */
#define  WIN_DIV  8

int main()
{
  Display *d;
  Window w, root, child;
  GC gc;
  XEvent e;
  int width, height, rx, ry, wx, wy, xx, yy;
  unsigned int mask;

  d = XOpenDisplay(NULL);
  w = XCreateSimpleWindow(d, RootWindow(d, 0),  25,  25,
         DisplayWidth(d, 0)/WIN_DIV, DisplayHeight(d, 0)/WIN_DIV,
         2, BlackPixel(d, 0), WhitePixel(d, 0));
  /* ɥȥ */
  XStoreName(d, w, "XTrace");
  gc = XCreateGC(d, w, 0, 0);
  XMapWindow(d, w);
  /* ݥ󥿽ɸ */
  XQueryPointer(d, w, &root, &child, &xx, &yy, &wx, &wy, &mask);

  while (1) {
    /* ݥ󥿤ΰ֤ȥܥ֤ʤɤξȲ */
    XQueryPointer(d, w, &root, &child, &rx, &ry, &wx, &wy, &mask);
    /* פɽ */
    XDrawLine(d, w, gc, rx/WIN_DIV, ry/WIN_DIV, xx/WIN_DIV, yy/WIN_DIV);
    xx = rx;  yy = ry;
    /* ܥ󲡲ɽ */
    if (mask & (Button1Mask | Button2Mask | Button3Mask))
      XDrawArc(d, w, gc, rx/WIN_DIV, ry/WIN_DIV, 2, 2, 0, 360*64);
    /* ٻߡʣá */
    usleep(100000);
  }

}
