/*
 * title : makedata.c
 * begin : 2002/04/05
 * note  : 
 * make  : gcc makedata.c -o makedata -lm
 * 
 */

#include <stdio.h>
#include <math.h>

#define  DIV   50
#define  R     1.0
#define  R1    1.0
#define  R2    2.0

int main(int argc, char **argv)
{
  int i, n0, n1, n2, n3;
  double th, x, y, z;
  int idx = 1, div = DIV;

  /* ޥɥ饤󤫤ѥ᥿ */
  while (idx < argc) {
    /* إɽ */
    if (strcmp(argv[idx], "-h") == 0) {
      fprintf(stderr, "*** cubic frame data generator\n");
      fprintf(stderr, "Usage : %s <number of frame segment>\n", argv[0]);
      fprintf(stderr, "sorry, no options.\n");
      fprintf(stderr, "see document for more informations, thanks.\n");
      exit(1);
    } else
      sscanf(argv[idx], "%d", &div);
    idx++;
  }
  if (div < 3) div = 3;

  /* coordination set generaate */
  printf("%g  %g  %g\n", 0, 0, 0);
  for (i = 0; i < div; i++) {
    th = (M_PI*2) * i / div;
    x = R * R1 * cos(th);
    y = R * R1 * sin(th);
    z = 0;
    printf("%g  %g  %g\n", x, y, z);
    x = R * R2 * cos(th);
    y = R * R2 * sin(th);
    z = 1;
    printf("%g  %g  %g\n", x, y, z);
  }
  /* data separator */
  printf("\n");
  /* line connection data generate */
  for (i = 0; i < div; i++) {
    n0 = 2*i+1;
    n1 = n0+1;
    n2 = n0+2; if (i == div - 1) n2 = 1;
    n3 = n0+3; if (i == div - 1) n3 = 2;
    printf("%d %d\n", 0,  n0);
    printf("%d %d\n", n0, n1);
    printf("%d %d\n", n0, n2);
    printf("%d %d\n", n1, n3);
  }

}
