/* 
 * title : showtama.c - show Tama image
 * begin : 2002/03/27
 * make  : gcc showtama.c -o showtama -I/usr/X11R6/include -L/usr/X11R6/lib -lX11
 * note  : ӥåȥޥåײɽ
 */

#include  <X11/Xlib.h>
#include  <X11/Xutil.h>
#include  <stdio.h>

/* ֵפȡΥޥΥѥ */
#include  "tama.xbm"
#include  "tama_msk.xbm"
/* ɥΣܤ礭ˤ */
#define  WIN_WIDTH   (tama_width  * 5)
#define  WIN_HEIGHT  (tama_height * 5)

int main()
{
  Display  *d;
  Window  w;
  Pixmap  pat, msk, back;
  GC  gc, gc1;
  XEvent  e;
  XSetWindowAttributes  att;
  XColor  col_red, col_green;

  d = XOpenDisplay(NULL);
  /* ֤ФȤ٤ν */
  { XColor  col_exact;
    XAllocNamedColor(d, DefaultColormap(d, 0), "red", &col_red, &col_exact);
    XAllocNamedColor(d, DefaultColormap(d, 0), "green", &col_green, &col_exact);
  }
  /* ɽ륦ɥ */
  w = XCreateSimpleWindow(d, RootWindow(d, 0), 0, 0, WIN_WIDTH, WIN_HEIGHT, 0, BlackPixel(d, 0), WhitePixel(d, 0));
  /* ȥޥ */
  XSelectInput(d, w, ExposureMask | ButtonPressMask);
  /* ֵץѥԥåޥåפɤ߹Ǥ */
  /* ӥåȥޥåפιʬϹˡʬˤ֤ŬѤ */
  pat = XCreatePixmapFromBitmapData(d, w, tama_bits, tama_width, tama_height, BlackPixel(d, 0), col_red.pixel, DefaultDepth(d, 0));
  /* ޥѥϥӥåȥޥåפ */
  msk = XCreateBitmapFromData(d, w, tama_msk_bits, tama_width, tama_height);
  /* 롼ȥɥѤΣǣ */
  gc = XCreateGC(d, RootWindow(d, 0), 0, 0);
  /* ϡֵץѥɽΰ٤Σǣ */
  gc1 = XCreateGC(d, w, 0, 0);
  XSetForeground(d, gc1, col_green.pixel);
  /*  */
  XSetSubwindowMode(d, gc, IncludeInferiors);
  back = XCreatePixmap(d, w, WIN_WIDTH, WIN_HEIGHT, DefaultDepth(d, 0));
  XCopyArea(d, RootWindow(d, 0), back, gc, 0, 0, WIN_WIDTH, WIN_HEIGHT, 0, 0);
  /* ɥطʤꤷƤ */
  XSetWindowBackgroundPixmap(d, w, back);
  /* ޥѥ */
  XSetClipMask(d, gc1, msk);
  /* ޥְư */
  XSetClipOrigin(d, gc1, tama_width, tama_height);

  XMapWindow(d, w);

  while (1) {
    XNextEvent(d, &e);
    if (e.type == ButtonPress)
      break;
    else 
    if (e.type == Expose) {
      /* ֵפɽ */
      XCopyArea(d, pat, w, gc1, 0, 0, tama_width, tama_height, tama_width, tama_height);
      /* ФޥƤΤǡʬˤΤ */
      { int i;
        for (i = 0; i < WIN_HEIGHT; i+=3)
          XDrawLine(d, w, gc1, 0, i, WIN_WIDTH, i);
      }
    }
  }
  XCloseDisplay(d);
}


